#ifndef MB_PRECOMPUTED_PLAN_CLIENT_H
#define MB_PRECOMPUTED_PLAN_CLIENT_H

#include <actionlib/client/simple_action_client.h>
#include <ros/ros.h>
#include <thread>
#include <move_base_msgs/MoveBaseAction.h>

class MBPrecomputedPlanClient
{
  using MoveBaseClient = actionlib::SimpleActionClient<move_base_msgs::MoveBaseAction>;

public:
  MBPrecomputedPlanClient() = delete;
  MBPrecomputedPlanClient(ros::NodeHandle& private_nh);

  ~MBPrecomputedPlanClient();

  void sendGoalToServer();

private:
  ros::NodeHandle private_nh_;
  MoveBaseClient ac_;
  bool loop_;
  std::string map_frame_;
  std::thread kill_signal_watcher_;
};

#endif  // MB_PRECOMPUTED_PLAN_CLIENT_H
